GLFW: Initialization, version and error reference

GLFW

- Documentation
- Download
- Media
- Community

- Main Page
- Related Pages
- Modules
- Data Structures
- Files

All Data Structures Files Functions Variables Typedefs Macros Groups Pages
Modules | Typedefs | Functions
Initialization, version and error reference

## Modules
| Error codes

## Typedefs
typedef void(* | GLFWerrorfun )(int, const char *)
| The function signature for error callbacks. More...

## Functions
int | glfwInit (void)
| Initializes the GLFW library. More...
void | glfwTerminate (void)
| Terminates the GLFW library. More...
void | glfwGetVersion (int *major, int *minor, int *rev)
| Retrieves the version of the GLFW library. More...
const char * | glfwGetVersionString (void)
| Returns a string describing the compile-time configuration. More...
GLFWerrorfun | glfwSetErrorCallback (GLFWerrorfun cbfun)
| Sets the error callback. More...

## GLFW version macros
#define | GLFW_VERSION_MAJOR 3
| The major version number of the GLFW library. More...
#define | GLFW_VERSION_MINOR 2
| The minor version number of the GLFW library. More...
#define | GLFW_VERSION_REVISION 1
| The revision number of the GLFW library. More...

## Detailed Description

This is the reference documentation for initialization and termination of the library, version management and error handling. For more task-oriented information, see the Introduction to the API.

## Macro Definition Documentation

#define GLFW_VERSION_MAJOR 3

This is incremented when the API is changed in non-compatible ways.

#define GLFW_VERSION_MINOR 2

This is incremented when features are added to the API but it remains backward-compatible.

#define GLFW_VERSION_REVISION 1

This is incremented when a bug fix release is made that does not contain any API changes.

## Typedef Documentation

typedef void(* GLFWerrorfun)(int, const char *)

This is the function signature for error callback functions.

Parameters

  [in] | error | An error code.
  [in] | description | A UTF-8 encoded string describing the error.

See Also
  Error handling
  glfwSetErrorCallback

Since
  Added in version 3.0.

## Function Documentation

void glfwGetVersion | ( | int * | major,
|  | int * | minor,
|  | int * | rev
| ) |  |

This function retrieves the major, minor and revision numbers of the GLFW library. It is intended for when you are using GLFW as a shared library and want to ensure that you are using the minimum required version.

Any or all of the version arguments may be `NULL`.

Parameters

  [out] | major | Where to store the major version number, or `NULL`.
  [out] | minor | Where to store the minor version number, or `NULL`.
  [out] | rev | Where to store the revision number, or `NULL`.

Errors
  None.

Remarks
  This function may be called before glfwInit.

Thread safety
  This function may be called from any thread.

See Also
  Version management
  glfwGetVersionString

Since
  Added in version 1.0.

const char* glfwGetVersionString | ( | void |  | ) |

This function returns the compile-time generated version string of the GLFW library binary. It describes the version, platform, compiler and any platform-specific compile-time options. It should not be confused with the OpenGL or OpenGL ES version string, queried with `glGetString`.

Do not use the version string to parse the GLFW library version. The glfwGetVersion function provides the version of the running library binary in numerical format.

Returns
  The ASCII encoded GLFW version string.

Errors
  None.

Remarks
  This function may be called before glfwInit.

Pointer lifetime
  The returned string is static and compile-time generated.

Thread safety
  This function may be called from any thread.

See Also
  Version management
  glfwGetVersion

Since
  Added in version 3.0.

int glfwInit | ( | void |  | ) |

This function initializes the GLFW library. Before most GLFW functions can be used, GLFW must be initialized, and before an application terminates GLFW should be terminated in order to free any resources allocated during or after initialization.

If this function fails, it calls glfwTerminate before returning. If it succeeds, you should call glfwTerminate before the application exits.

Additional calls to this function after successful initialization but before termination will return `GLFW_TRUE` immediately.

Returns
  `GLFW_TRUE` if successful, or `GLFW_FALSE` if an error occurred.

Errors
  Possible errors include GLFW_PLATFORM_ERROR.

Remarks
  OS X: This function will change the current directory of the application to the `Contents/Resources` subdirectory of the application's bundle, if present. This can be disabled with a compile-time option.

Thread safety
  This function must only be called from the main thread.

See Also
  Initialization and termination
  glfwTerminate

Since
  Added in version 1.0.

GLFWerrorfun glfwSetErrorCallback | ( | GLFWerrorfun | cbfun | ) |

This function sets the error callback, which is called with an error code and a human-readable description each time a GLFW error occurs.

The error callback is called on the thread where the error occurred. If you are using GLFW from multiple threads, your error callback needs to be written accordingly.

Because the description string may have been generated specifically for that error, it is not guaranteed to be valid after the callback has returned. If you wish to use it after the callback returns, you need to make a copy.

Once set, the error callback remains set even after the library has been terminated.

Parameters

  [in] | cbfun | The new callback, or `NULL` to remove the currently set callback.

Returns
  The previously set callback, or `NULL` if no callback was set.

Errors
  None.

Remarks
  This function may be called before glfwInit.

Thread safety
  This function must only be called from the main thread.

See Also
  Error handling

Since
  Added in version 3.0.

void glfwTerminate | ( | void |  | ) |

This function destroys all remaining windows and cursors, restores any modified gamma ramps and frees any other allocated resources. Once this function is called, you must again call glfwInit successfully before you will be able to use most GLFW functions.

If GLFW has been successfully initialized, this function should be called before the application exits. If initialization fails, there is no need to call this function, as it is called by glfwInit before it returns failure.

Errors
  Possible errors include GLFW_PLATFORM_ERROR.

Remarks
  This function may be called before glfwInit.

Warning
  The contexts of any remaining windows must not be current on any other thread when this function is called.

Reentrancy
  This function must not be called from a callback.

Thread safety
  This function must only be called from the main thread.

See Also
  Initialization and termination
  glfwInit

Since
  Added in version 1.0.